Bug 121082 - Can't configure isa-pnp devices at boot
Can't configure isa-pnp devices at boot
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
1
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-04-16 17:54 EDT by Lee Olsen
Modified: 2007-11-30 17:10 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-29 16:20:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
diff -u for mkinitrd, isapnp.c, and isapnp_proc.c (12.31 KB, text/plain)
2004-04-16 18:03 EDT, Lee Olsen
no flags Details

  None (edit)
Description Lee Olsen 2004-04-16 17:54:44 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.4.1)
Gecko/20031030

Description of problem:
isa-pnp configuration happens too late if at all. If the module is
loaded from linuxrc on the initrd, no post-install gets run and no
configuration takes place. /etc/rc.sysinit skips isapnp configuration
if the /proc interface exists.
What needs to happen is mkinitrd needs to convert post-install's that
cat > /proc/somewhere into a series of echo > /proc/somewhere (since
cat does not exist on initrd). mkinitrd also needs to mount /proc
before loading modules instead of after as it does now.
In addition, isa-pnp needs to accept multiple command fragments on a
single line. Currently it expects "card", "port", "dma", "irq" settings
on separate lines. I propose adding ';' to the '\n' terminator test to
combine the fragments on a single line. I propose using "#Begin" and
"#End" comments in the catted config file to tell mkinitrd how to block
the fragments.
nash and isapnp_proc.c don't agree on which open modes are writable.
nash's echo > file opens file read/write (which is wrong) and
isapnp_proc expects either readonly or writeonly, rejecting readwrite.
I propose making isapnp_proc more tolerant as long as there are other
changes going in.
While reformatting the output from /proc/isapnp, making it suitable
for input to itself, the way isapnptools was, makes updating
configurations much easier.
I'd also like a different order for interrupt allocation, starting
with least frequently used and saving popular ones for later. Giving
away 5 and 10 early makes activating sound cards difficult or impossible.


Version-Release number of selected component (if applicable):
.4.22-1.2174.nptl

How reproducible:
Always

Steps to Reproduce:
1.Hardware configuration needs a printer, isapnp lan card, sb16 with
attached cdrom
2.isapnp_reserve_irq=7 # for printer
3.reboot

    

Actual Results:  4.ide driver uses default irq 10 for ide3 (sb16 cdrom)
5.isapnp allocates irq 5 to the lan card
6.modprobe sb complains about out of resources

Expected Results:  setting either the sb16 to ide1 or ide2 in
/etc/isa-pnp.conf would
allow the sb audio device to load. Changing the interrupt allocation
to use 12, 15, 11, before 5 or 10 would also allow the sb to load.
(sb uses irq 5/7/10 only)

Additional info:

I have suggested patches for mkinitrd, isapnp.c, and isapnp_proc.c
that I will upload once this is in the database.
Comment 1 Lee Olsen 2004-04-16 18:03:50 EDT
Created attachment 99499 [details]
diff -u for mkinitrd, isapnp.c, and isapnp_proc.c
Comment 2 David Lawrence 2004-09-29 16:20:27 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.